# $Id: DBConnection.py,v 1.17 2004/11/24 06:53:31 hmichelon Exp $
import string
import sys
import pygtk
pygtk.require('2.0')
import gtk
# imports below for cx_Freeze
import gtk.glade
import gtk.gdk
import atk
import gtk._gtk
import pango


try:
  from mx import DateTime
except ImportError:
  dialog = gtk.MessageDialog(
              None,
              gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
              gtk.MESSAGE_INFO,
              gtk.BUTTONS_OK,
              "Please install the mxDateTime python package from http://www.egenix.com/files/python/mxDateTime.html")
  dialog.run()
  dialog.destroy()
  sys.exit(1)

try:
  from pyPgSQL import libpq
except ImportError:
  dialog = gtk.MessageDialog(
              None,
              gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
              gtk.MESSAGE_INFO,
              gtk.BUTTONS_OK,
              "Please install the pyPgSQL python package from http://pypgsql.sourceforge.net/")
  dialog.run()
  dialog.destroy()
  sys.exit(1)

import MyPgSQL
  

class DBConnection:
  """Database connection/deconnection and query execution"""

  def __init__(self, host = None, port = None, db = None, user = None, password = None):
    """Try to connect to a database"""
    dsn = ""
    if (host is not None): dsn = host
    dsn = dsn + ":"  
    if (port is not None): dsn = dsn + str(port)
    dsn = dsn + ":"  
    if (db is not None): dsn = dsn + db
    dsn = dsn + ":"  
    if (user is not None): dsn = dsn + user
    dsn = dsn + ":"  
    if (password is not None): dsn = dsn + password
    try:
      self.db = MyPgSQL.connect(dsn)
      self.db.autocommit = 1
      self.host = host
      self.port = port
      self.database = db
      self.user = user
      self.password = password
    except libpq.DatabaseError:
      self.db = None


  def pgversion(self):
    if (self.is_connected()):
      v = string.split(str(self.db.version), ',')
      return v.pop(0)
    return ''


  def query(self, sql):
    """Execute a query and return the corresponding DB-API cursor."""
    if not self.is_connected() : return None
    cursor = self.db.cursor()
    try:
      cursor.execute("SET CLIENT_ENCODING TO 'UTF-8'")
      cursor.execute(sql)
    except libpq.OperationalError, msg:
      cursor.close()
      return { 'error' : str(msg), 'notices' : self.db.notices }
    return { 'cursor' : cursor, 'notices' : self.db.notices }
  

  def commit(self):
    if not self.is_connected() : return
    self.db.commit()


  def is_connected(self):
    return (self.db != None)


  def disconnect(self):
    if not self.is_connected() : return
    self.db.close()
    self.db = None
