# $Id: GladeClass.py,v 1.11 2004/11/22 08:49:02 hmichelon Exp $
import os
import pygtk
pygtk.require('2.0') # comment this for cx_Freeze
import gtk
import gtk.glade
# imports below for cx_Freeze
import gtk.glade
import gtk.gdk
import atk
import gtk._gtk
import pango



class GladeClass:
  """Common methods of all Glade based programs"""
  
  def __init__(self, path, glade_file, domainname):
    """Load the Glade file and connect signals to methods"""
    if (path != ""):
      path = path + os.path.sep + glade_file
    else:
      path = glade_file
    self.ui = gtk.glade.XML(path, None, domain=domainname)
    dic = {}
    for iteration in dir(self.__class__):
      if (iteration[0:3] == "on_"):
        dic[iteration]=getattr(self,iteration)
    self.ui.signal_autoconnect(dic)


  def widget(self, widget_name):
    """return a widget by is name"""
    return self.ui.get_widget(widget_name);


  def set_widget_text(self, widget, text):
    """Change the text of a widget"""
    if (isinstance(widget, str)):
      widget = self.widget(widget)
    if (isinstance(widget, gtk.TextView)):
      widget.get_buffer().set_text(text);


  def get_widget_text(self, widget):
    """Return the text of a widget"""
    if (isinstance(widget, str)):
      widget = self.widget(widget)
    if (isinstance(widget, gtk.TextView)):
      buffer = widget.get_buffer()
      c1 = buffer.get_start_iter()
      c2 = buffer.get_end_iter()
      return buffer.get_slice(c1, c2, gtk.TRUE)
    return None
  

  def message_box(self, msg):
    dialog = gtk.MessageDialog(
        self.window,
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
        gtk.MESSAGE_INFO,
        gtk.BUTTONS_OK,
        msg
        )
    dialog.run()
    dialog.destroy()

  
  def error_box(self, msg):
    dialog = gtk.MessageDialog(
        self.window,
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
        gtk.MESSAGE_WARNING,
        gtk.BUTTONS_OK,
        msg
        )
    dialog.run()
    dialog.destroy()


  def yesno_box(self, msg):
    dialog = gtk.MessageDialog(
        self.window,
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
        gtk.MESSAGE_QUESTION,
        gtk.BUTTONS_YES_NO,
        msg
        )
    result = dialog.run()
    dialog.destroy()
    return result


  def openfile_dialog(self, sTitleMessage):
    sFile = '';
    try:
      fb = gtk.FileChooserDialog(sTitleMessage, self.window,
                                 gtk.FILE_CHOOSER_ACTION_OPEN,
                                 (gtk.STOCK_CANCEL,
                                  gtk.RESPONSE_CANCEL,
                                  gtk.STOCK_OPEN,
                                  gtk.RESPONSE_OK))
    except:
      fb = gtk.FileSelection(sTitleMessage)
      fb.set_position(gtk.WIN_POS_CENTER)
    fb.show_all()
    result = fb.run()
    fb.hide()
    if (result == gtk.RESPONSE_OK):
      return fb.get_filename()
    return None
